{$F-,A+,O+,G+,R-,S+,I+,Q-,V-,B-,X+,T-,P-,D-,L-,N-,E+}
unit bbsInit;

interface

procedure fixUsers;
procedure killTerminateBBS;
procedure killVariables;
procedure initCommPort;
procedure initFiles;
procedure initParameters;
procedure initPaths;
procedure initVariables;
procedure resetArchivers;
procedure resetCfg;
procedure resetMessage;
procedure resetModem;
procedure resetProtocols;
procedure resetVariables(Full : Boolean);

implementation

uses Crt, Global, Strings, Files, Comm, Misc, Swap, Screen, MsgArea, Detect,
     Config1, Config2, Config3, Config4, Config8, FastIO, Logs, Users,
     DateTime, FileArea, FileSort, Nodes;

procedure resetVariables(Full : Boolean);
begin
   ChatModeOn := False;
   DetANSi := False;
   DetAVATAR := False;
   DetRIP := False;
   ExecFirst := False;
   Hangup := False;
   Hungup := False;
   OkFlag := False;
   PauseAbort := False;
   QuitAfter := False;
   LocKey := True;
   LoggedIn := False;
   RemoteIn := True;
   RemoteOut := False;
   ScreenOff := False;
   StringEdit := False;
   TempSysOp := False;
   UserOn := False;
   NewMnuToLoad := True;
   NewMenuCmd := '';
   CmdList := '';
   chatReason := '';
   Baudrate := 0;
   emailTag := 0;
   readTag := 0;
   useTag := False;
   numBatch := 0;
   scrCol.Fore := $07;
   scrCol.Back := $00;
   scrCol.Blink := False;
   Col := scrCol;
   saveCol := scrCol;
   colAttr := $07;
   posX := 1;
   posY := 1;
   savX := 1;
   savY := 1;
   scrX := 1;
   scrY := 1;
   doHelp := False;
   macroPos := 0;
   pausePos := 0;
   curMsg       := 0;
   timeEvent    := 0.0;
   timeExtra    := 0.0;
   timeFree     := 0.0;
   extKey := #0;
   FillChar(MenuStack,SizeOf(MenuStack),#0);
   LastMenu := Cfg^.StartMenu;
   CurMenu := Cfg^.StartMenu;
   MenuPtr := 0;
   mandMsg := False;
   fConfAll := False;
   posX := 1;
   posY := 1;

   if not Full then Exit;

   LocalIO := False;
   ModemIO := False;
   ModemOff := False;
   tLibOpen := False;
   Node := 1;
   ErrorLevel := 0;
   scrTop := 1;
   scrBot := 25;
   curStat := 1;
   ansiRows := 0;
   macroNum := 0;
   oprDelay := 100;


   numCmds      := 0;
   numEvent     := 0;
   numMsgArea   := 0;
   numFileArea  := 0;
   numUsers     := 0;
   numMsg       := 0;
   numMsgConf   := 0;
   numFileConf  := 0;
   numLib       := 0;
end;

procedure resetCfg;
var I : Word;
begin
   FillChar(Cfg^,SizeOf(tCfgRec),0);
   with Cfg^ do
   begin

      bbsName                := bbsTitle;
      bbsPhone               := '(000)000-0000';
      SysOpAlias             := 'SysOp';
      SysOpName              := 'System Operator';
      SystemPW               := 'SYSTEM';
      acsSysOp               := 's255';
      acsCoSysOp             := 's250';
      DirectWrites           := True;
      SnowChecking           := False;
      OverlayToEMS           := True;
      RealNameSystem         := False;
      ShowPwLocal            := True;
      iniqAsDoor             := False;

      StatOnDefault          := True;
      StatBarOn              := True;
      StatType               := sbBot;
      StatBar                := 1;
      StatLo                 := $10;
      StatTxt                := $17;
      StatHi                 := $1F;

      for I := 0 to maxColor do
      begin
         DefaultCol[I].Fore := 7;
         DefaultCol[I].Back := 0;
         DefaultCol[I].Blink := False;
      end;

      DefaultCol[colError].Fore  := 12;

      DefaultCol[colText].Fore   := 7;
      DefaultCol[colTextLo].Fore := 8;
      DefaultCol[colTextHi].Fore := 15;

      DefaultCol[colInfo].Fore   := 1;
      DefaultCol[colInfoLo].Fore := 8;
      DefaultCol[colInfoHi].Fore := 9;

      DefaultCol[colItem].Fore := 8;
      DefaultCol[colItemSel].Fore := 8;
      DefaultCol[colItemSel].Back := 7;

      DefaultCol[colBorder].Fore := 8;

      DefaultCol[colEdit].Fore := 15;
      DefaultCol[colEdit].Back := 1;

      ESCtoExit              := True;
      OffhookLocal           := True;
      VgaEffects             := False;
      ScreenSaver            := 2;
      BlankSeconds           := 180;
      DefWFCstat             := 8;

      pathData               := StartDir+'DATA\';
      pathText               := StartDir+'TEXT\';
      pathMenu               := StartDir+'MENU\';
      pathMsgs               := StartDir+'MSGS\';
      pathSwap               := StartDir+'SWAP\';
      pathDoor               := StartDir+'DOOR\';
      pathProt               := StartDir+'PROT\';
      pathTemp               := StartDir+'TEMP\';
      pathDnld               := StartDir+'DNLD\';
      pathLogs               := StartDir+'LOGS\';
      pathArch               := StartDir+'ARCH\';
      pathAtch               := StartDir+'ATCH\';

      NoBBSlogging           := False;
      LogLineChat            := True;
      LogSplitChat           := True;
      LogMicroDOS            := True;

      SwapInShell            := True;
      SwapToEMS              := True;
      ProtocolSwap           := True;
      ArchiverSwap           := True;

      BbsAccessPw            := '';
      NoBaudPW               := '';
      SysOpAutoLogin         := False;
      MatrixLogin            := True;
      AskApply               := True;
      TimeLimitPerCall       := False;
      acsSystemPWLogin       := 's250';
      CallsBirth             := 10;
      CallsPhone             := 5;
      LoginTrys              := 5;

      Origin[1] := bbsTitle+' -- '+bbsPhone;

      NoChatPW               := '';
      ChatPageNoise          := True;
      maxPageTimes           := 3;
      maxPageBeeps           := 6;
      restoreChatTime        := True;

      PwEchoChar             := '';
      RemovePause            := True;
      AddLocalCalls          := False;
      numLastCalls           := 10;

      acsPostEmail           := 's25';
      acsAnonymous           := 's50';
      acsAnonAutoMsg         := 's50';
      acsUploadMessage       := 's25';
      acsAutoSigUse          := 's25';
      acsAttachPublic        := 's50';
      acsAttachEmail         := 's50';
      AbortMandOk            := False;
      AskPrivateMsg          := True;
      AskPrivateReply        := True;
      AskPostInArea          := True;
      AskUploadReply         := False;
      AskUploadEmail         := True;
      AskKillMsg             := True;
      AskKillAllMsg          := True;
      AskAutoQuote           := True;
      DefaultQuoteNum        := True;
      maxQuoteLines          := 11;
      confIgnoreMsg          := True;
      compMsgAreas           := True;

      NewUserPW              := '';
      AliasFormat            := 2;
      DefaultPageLen         := 24;
      NewExpert              := False;
      NewYesNoBars           := True;
      NewHotKeys             := True;
      NewPause               := True;
      NewQuote               := True;
      NewAskExpert           := True;
      NewAskYesNoBars        := True;
      NewAskHotKeys          := True;
      NewAskPageLen          := True;
      NewAskPause            := True;
      NewAskQuote            := True;
      StartMenu              := 'STARTUP';

      compFileAreas          := True;
      kbPerFilePoint         := 15;
      useFilePoints          := False;
      importDescs            := True;
      useDLlimit             := True;
      useDLkbLimit           := True;
      bbsLocation            := 'Somewhere, XX';
      qwkFilename            := UpStr(bbsTitle);
      qwkWelcome             := txWelcome+'.ANS';
      qwkNews                := 'NEWS.ANS';
      qwkGoodbye             := txLogoff+'.ANS';
      qwkLocalPath           := StartDir;
      qwkIgnoreTime          := True;
      qwkStripSigs           := True;
      noDescLine             := 'No description';
      waitConnect            := 45;
      modemReInit            := 600;
      lightChar              := '';
      lightCharOk            := '';
      lightCharFail          := 'x';
      virusScan              := 'SCAN /NOMEM /NOEXPIRE /SUB %FN';
      virusOk                := 0;
      maxFileAge             := 4;
      strictAge              := True;
      delFile                := 'DELETE.LST';
      addFile                := 'ADD.LST';
      comFile                := 'COMMENT.TXT';
      extMaint               := False;
      ulSearch               := 4;
      autoValidate           := True;
      filePtsPer             := 175;
      useUlDlratio           := False;
      useKbRatio             := False;
      fileDesc1              := 'FILE_ID.DIZ';
      fileDesc2              := 'DESC.SDI';
      useTextLibs            := True;
      pathLibs               := StartDir+'LIBS\';
      echomailLev            := 100;
      newConfig              := True;
      newVerify              := True;
      pmtYes                 := '|U5[|U6Y|U5/|U4n|U5] |U6';
      pmtNo                  := '|U5[|U4y|U5/|U6N|U5] |U6';
      pmtYesWord             := 'Yes';
      pmtNoWord              := 'No';
      pmtYesBar              := '|U8 Yes |U7 No ';
      pmtNoBar               := '|U7 Yes |U8 No |U1';
      descWrap               := True;
      chatStart              := '11:00';
      chatEnd                := '20:00';
      chatOverAcs            := 's150';
      advFileBar             := True;
      inactTime              := True;
      inactSeconds           := 180;
      inactWarning           := 120;
      ansiString             := '(Ansi codes detected; line not displayed)';
      pageAskEmail           := True;
      soundRestrict          := True;
      inactLocal             := True;
      allowBlind             := True;
      nuvVotesYes            := 5;
      nuvVotesNo             := 3;
      nuvAccess              := '!s50';
      nuvVoteAccess          := 's50';
      nuvInitials            := True;
      nuvUserLevel           := 'B';
      nuvValidation          := True;
      MultiNode              := False;
   end;
end;

procedure resetModem;
begin
   FillChar(Modem^,SizeOf(tModemRec),0);
   with Modem^ do
   begin
      ComPort       := 4; { Local }
      BaudRate      := 38400;
      Parity        := 'N';
      StopBits      := 1;
      DataBits      := 8;
      LockedPort    := True;
      MultiRing     := False;
      irqNumber     := 3;
      irqString     := '02F8';

      sInit1        := 'ATH0E1&C1&D2&A3S0=0|';
      sInit2        := '';
      sInit3        := '';
      sExitStr      := '';
      sAnswer       := 'ATA|';
      sHangup       := 'ATH0|';
      sOffhook      := 'ATH1|';
      sDialPrefix   := 'ATDT';

      rError        := 'ERROR';
      rNoCarrier    := 'NO CARRIER';
      rOK           := 'OK';
      rRing         := 'RING';
      rBusy         := 'BUSY';

      c300          := 'CONNECT';
      c1200         := 'CONNECT 1200';
      c1275         := 'CONNECT 1275';
      c2400         := 'CONNECT 2400';
      c4800         := 'CONNECT 4800';
      c7200         := 'CONNECT 7200';
      c9600         := 'CONNECT 9600';
      c12000        := 'CONNECT 12000';
      c14400        := 'CONNECT 14400';
      c16800        := 'CONNECT 16800';
      c19200        := 'CONNECT 19200';
      c21600        := 'CONNECT 21600';
      c24000        := 'CONNECT 24000';
      c26400        := 'CONNECT 26400';
      c28800        := 'CONNECT 28800';
      c38400        := 'CONNECT 38400';
      c57600        := 'CONNECT 57600';
      c64000        := 'CONNECT 64000';
      c115200       := 'CONNECT 115200';
   end;
end;

procedure fixUsers;
var F : file of tUserRec; U : tUserRec; Z : Word;
begin
   Assign(F,Cfg^.pathData+fileUsers);
   {$I-}
   Reset(F);
   {$I+}
   Z := 0;
   if ioResult <> 0 then Exit;
   while not Eof(F) do with U do
   begin
      Inc(Z,1);
      Read(F,U);

      Username := strMixed(Username);
      Realname := strMixed(Realname);

      FirstCall    := dtDateString;
      StartMenu    := Cfg^.StartMenu;
      fileScan     := '01/01/80';
      SysOpNote    := 'None';
      Posts        := 0;
      Email        := 0;
      Uploads      := 0;
      Downloads    := 0;
      UploadKb     := 0;
      DownloadKb   := 0;
      CallsToday   := 0;
      Flag         := [];
      filePts      := 100;
      postCall     := 10;
      limitDL      := 10;
      limitDLkb    := 1400;
      todayDL      := 0;
      todayDLkb    := 0;

      FillChar(Reserved,SizeOf(Reserved),0);
      Seek(F,Z-1);
      Write(F,U);
   end;
   Close(F);
end;

function resetString(sn : Word) : String;
var s : String;
begin
   FillChar(s,SizeOf(s),0);
   case sn of
       strDetectEmu         : S := '|CS( detecting emulation )';
       strDetectNone        : S := '|CS( failed detection )';
       strDetectANSi        : S := '|CS|U3Ansi |U1detected|U2.';
       strDetectAVATAR      : S := '|CS|U3Avatar |U1detected|U2.';
       strDetectRIP         : S := '|CS|U3Rip |U1detected|U2.';
       strConnectedAt       : S := '|U1Connected at |U3%S1 |U1baud|U2.';
       strLoginSystemPW     : S := '|15sy|07st|08em   : |07';
       strAskSystemPW       : S := '|15|07-|08- |15S|07y|08stem |15p|07a|08ssword: ';
       strPause             : S := '|07/|15-|07-|08\ |10Pa|02use|08d <|15q|08>|07uit |08<|15c|08>|07ontinuous '+
                                   '|07/|15-|07-|08\';
       strHitAKey           : S := '|08-|04-|12[ |15p|07res|08s |15a|07n|08y |15k|07e|08y |07t|08o |15c|07onti'+
                                   'nu|08e |12]-|04-|08-';
       strMenuPassword      : S := '|08/|07-|08\ |15Enter menu access password|08: |07';
       strMenuAccessDenied  : S := '|12-|04-|08- |12Ac|04ces|08s |04t|08o |12me|04n|08u |12de|04nie|08d.';
       strCmdAccessDenied   : S := '|12-|04-|08- |12Com|04man|08d |12ac|04ces|08s |12de|04nie|08d.';
       strInvalidCommand    : S := '|15-|07-|08- |12Inv|04ali|08d |12com|04man|08d.';
       strInvalidMnuCmd     : S := '|15-|07-|08- |12Inv|04ali|08d |12me|04n|08u |12com|04man|08d: "|07%S1|08".';
       strLoginName         : S := '|15|07-|08- |15L|07o|08gin: |07';
       strLoginPassword     : S := '|15|07-|08- |15P|07a|08ssword: |07';
       strLoginPhone        : S := '|15ph|07on|08e    : |08[|07xxx|08]|07xxx|08-|07';
       strLoginBDate        : S := '|15bd|07at|08e    : |07';
       strLoginUnknown      : S := 'Unknown user.';
       strLoginError        : S := 'Invalid login.';
       strLoginAskApply     : S := '|15ap|07pl|08y?   : ';
       strNuHandle          : S := '|09E|01n|08ter |09y|01o|08ur |09a|01l|08ias: |09';
       strNuName            : S := '|09E|01n|08ter |09y|01o|08ur |09r|01e|08al |09n|01a|08me: |09';
       strNuBirthDate       : S := '|09E|01n|08ter |09y|01o|08ur |09b|01i|08rthdate [|01mm|08/|01dd|08/|01yy|08]: |09';
       strNuPhoneNum        : S := '|09E|01n|08ter |09y|01o|08ur |09v|01o|08ice |09p|01h|08one |09n|01u|08mber: ';
       strNuAddress         : S := '|09E|01n|08ter |09y|01o|08ur |09s|01t|08reet |09a|01d|08dress: |09';
       strNuLocation        : S := '|09E|01n|08ter |09y|01o|08ur |09c|01i|08ty |09n|01a|08me: |09';
       strNuYesNoBar        : S := '|09U|01s|08e |09y|01e|08s/|09n|01o |09b|01a|08rs? ';
       strNuHotKey          : S := '|09U|01s|08e |09h|01o|08t|09k|01e|08ys |09f|01o|08r |09i|01n|08put? ';
       strNuExpertMode      : S := '|09U|01s|08e |01"|09e|01x|08pert" |09m|01o|08de? ';
       strNuPassword        : S := '|09E|01n|08ter |09a p|01a|08ssword |09t|01o |09u|01s|08e: |09';
       strNuBadAlias        : S := '|12|04-|08- |12I|04n|08valid |12u|04s|08ername.';
       strNuDupUser         : S := '|12T|04h|08at |12u|04s|08er |12a|04l|08ready |12e|04x|08ists.';
       strNuBadName         : S := '|12|04-|08- |12I|04n|08valid |12u|04s|08ername.';
       strNuFullName        : S := '|09Y|01o|08u |09m|01u|08st |09e|01n|08ter |09y|01o|08ur |09f|01i|08rst |09a|0'+
                                   '1n|08d |09l|01a|08st |09n|01a|08me.';
       strNuBadBirth        : S := '|12|04-|08- |12I|04n|08valid |12b|04i|08rthdate.';
       strNuSmallPassword   : S := '|12|04-|08- |12Y|04o|08ur |12p|04a|08ssword |12m|04u|08st |12b|04e |12a|04t '+
                                   '|12l|04e|08ast |124 c|04h|08aracters |12l|04o|08ng.';
       strNuValidatePW      : S := '        |09v|01e|08rify |09p|01a|08ssword: |09';
       strNuPWnoMatch       : S := '|12Y|04o|08ur |12p|04a|08sswords |12d|04o |12n|04o|08t |12m|04a|08tch.';
       strNuSavingInfo      : S := '|12|04-|08- |12S|04a|08ving |12y|04o|08ur |12i|04n|08formation ... |12p|04'+
                                   'l|08ease |12w|04a|08it.';
       strNuYourAgeIs       : S := '|09Y|01o|08u |09a|01r|08e |09%S1 y|01e|08ars |09o|01l|08d.';
       strNuAskSex          : S := '|09Y|01o|08ur |09s|01e|08x [|09M|08]|01ale|08/[|09F|08]|01emale|08? |09';
       strNuEnterNewUserPW  : S := '|09E|01n|08ter |09N|01U|08P: |09';
       strNuBadNewUserPW    : S := '|12|04-|08- |12N|04U|08P |12i|04n|08correct.';
       strChatInitiate      : S := '|LF|12|04-|08- |12C|04h|08at |12m|04o|08de |12i|04n|08itiated |12-|04-|08-|L'+
                                   'F';
       strChatTerminate     : S := '|LF|12|04-|08- |12C|04ha|08t |12m|04o|08de |12t|04e|08rminated |12-|04-|08-|'+
                                   'LF';
       strJumpToDOS         : S := '|LF|15|07-|08- |12S|04y|08sOp |12i|04n |12D|04O|08S |15-|07-|08-';
       strBackFromDOS       : S := '|LF|15|07-|08- |12S|04y|08sOp |12i|04s |12b|04a|08ck |15-|07-|08-';
       strFsAskAbort        : S := '|10|02-|08- |10A|02b|08ort |10m|02e|08ssage? ';
       strFsAskCommand      : S := '|15|07-|08- |15C|07o|08mmand |07[|15?|07|15H|07e|08lp] ';
       strFsCommandHelp     : S := '|15|07-|08- |15E|07d|08itor |15c|07o|08mmand? |07[|15?|07|15H|07e|08lp] ';
       strFsSavingMsg       : S := '|15|07-|08- |15S|07a|08ving |15m|07e|08ssage ...';
       strMsgNoPostAcs      : S := '|12Y|04o|08u |12d|04o |12n|04o|08t |12h|04a|08ve |12p|04o|08st |12a|04c|08ces'+
                                   's in this area.';
       strMsgAskWhoTo       : S := '|CS|11D|03e|08stination        : |07';
       strMsgAskPrivate     : S := '|11P|03r|08ivate |11m|03e|08ssage? ';
       strMsgAskTitle       : S := '|11E|03n|08ter |11m|03e|08ssage |11t|03i|08tle: |07';
       strMsgReadNoMsgs     : S := '|12|04-|08- |12M|04e|08ssage |12b|04a|08se |12i|04s |12e|04m|08pty.';
       strMsgReadStartAt    : S := '|12|04-|08- |12S|04t|08art |12r|04e|08ading |12a|04t |08|04[|121|04-|08%S1] |09';
       strMsgReadPrompt     : S := '|08-|01-|09-|01-|08 |15r|07eadi|08ng |15m|07essa|08ge |08[|13%S1 |05o|08f |05%S'+
                                   '2|08]  |09C|01omma|08nd |08[|15?|08/|07h|08elp, |15e|07nter|08/|07n|08ext|08]: ';
       strMsgReadAskPost    : S := '|10|02-|08- |10P|02o|08st |10i|02n |10t|02h|08is |10a|02r|08ea? ';
       strMsgAlterTitle     : S := '|15|07-|08- |15E|07n|08ter |15n|07e|08w |15m|07e|08ssage |15t|07i|08tle.';
       strMsgQuoteFirst     : S := '|10|02-|08- |10E|02n|08ter |10f|02i|08rst |10l|02i|08ne |10o|02f |10m|02e|08'+
                                   'ssage |10t|02o |10q|02u|08ote |02[|101|02-|08%S1]: |07';
       strMsgQuoteSecond    : S := '|10|02-|08- |10E|02n|08ter |10s|02e|08cond |10l|02i|08ne |10o|02f |10m|02e|0'+
                                   '8ssage |10t|02o |10q|02u|08ote |02[|10%S1|02-|08%S2]: |07';
       strMsgDeleted        : S := '|12|04-|08- |12M|04e|08ssage |12d|04e|08leted |12-|04-|08-';
       strMsgUndeleted      : S := '|12|04-|08- |12M|04e|08ssage |12u|04n|08deleted |12-|04-|08-';
       strMsgNewScanInit    : S := '|CS|LF|15|07-|08- |11G|03l|08obal |11n|03e|08wscan |11i|03n|08itiated.|LF';
       strMsgNewScanDone    : S := '|15|07-|08- |11G|03l|08obal |11n|03e|08wscan |11c|03o|08mpleted.|LF';
       strMsgNewScanStart   : S := '|12|04-|08- |12A|04r|08ea |12%S1 |08- |04[|12%S2 m|04s|08gs] - |12s|04c|08an'+
                                   'ning ...';
       strMsgNewScanEnd     : S := '|12|04-|08- |12A|04r|08ea |12%S1 |08- |04[|12%S2 m|04s|08gs] - |12c|04o|08mp'+
                                   'lete ...|LF';
       strMsgNewScanAskAll  : S := '|15|07-|08- |13N|05e|08wScan |13a|05l|08l |13m|05e|08ssage |13a|05r|08eas? ';
       strMsgPackStart      : S := '|12|04-|08- |12P|04a|08cking |12a|04r|08ea: |12%S1 |04[|12%S2 |04msgs|08] ...';
       strMsgPackEnd        : S := ' |12c|04o|08mplete.';
       strMsgPackAskAll     : S := '|10|02-|08- |10P|02a|08ck |10a|02l|08l |10m|02e|08ssage |10a|02r|08eas? ';
       strAnonymous         : S := '|AS|12An|04onym|08ous|AL';
       strNoAutoMsg         : S := '|12|04-|08- |12T|04h|08e |12a|04u|08tomessage |12i|04s |12e|04m|08pty |12-|'+
                                   '04-|08-';
       strMsgAskAnonymous   : S := '|11P|03o|08st |11a|03n|08onymously? ';
       strBBSaskName        : S := '|15B|07B|08S |15N|07a|08me         : |07';
       strBBSexists         : S := '|12|04-|08- |12T|04h|08at |12B|04B|08S |12i|04s |12a|04l|08ready |12i|04n |'+
                                   '12t|04h|08ere.';
       strBBSaskPhone       : S := '|15P|07h|08one |15N|07u|08mber     : |07';
       strBBSaskSysOp       : S := '|15S|07y|08sOp''s |15A|07l|08ias    : |07';
       strBBSaskBaud        : S := '|15M|07a|08ximum |15B|07a|08udrate : |07';
       strBBSaskSoftware    : S := '|15B|07B|08S |15S|07o|08ftware     : |07';
       strBBSaskStorage     : S := '|15M|07a|08x |15S|07t|08orage |07(|15m|07b|08) : |07';
       strBBSaskInfo        : S := '|15O|07t|08her |15I|07n|08fo       : |07';
       strBBSsavingEntry    : S := '|12|04-|08- |12S|04a|08ving |12e|04n|08try |12-|04-|08-';
       strBBSaskSaveBBS     : S := '|10|02-|08- |10S|02a|08ve |10e|02n|08try? ';
       strAutoMsgAnon       : S := '|U1Can''t reply to an anonymous automessage|U2.';
       strMsgReadMandatory  : S := '|LF|12|04-|08- |12Y|04o|08u |12m|04u|08st |12r|04e|08ad |12a|04l|08l |12o|0'+
                                   '4f |12t|04h|08e |12m|04e|08ssages |12i|04n |12t|04h|08is |12b|04a|08se |12-|'+
                                   '04-|08-';
       strBBSnoSystems      : S := '|12|04-|08- |12T|04h|08ere |12a|04r|08e |12n|04o |12e|04n|08tries |12-|04-|'+
                                   '08-';
       strBBSshowOne        : S := '|10|02-|08- |10D|02i|08splay |10w|02h|08ich |10B|02B|08S? |02[|101|02-|08%S'+
                                   '1]: |10';
       strNuAskPageLen      : S := '|09S|01c|08reen |09l|01e|08ngth |09i|01n |09r|01o|08ws: |09';
       strBBSdeleteOne      : S := '|10|02-|08- |10D|02e|08lete |10w|02h|08ich |10e|02n|08try? |02[|101|08-%S1]: |07';
       strBBSverifyKill     : S := '|10|02-|08- |10D|02e|08lete |10t|02h|08is |10e|02n|08try? ';
       strBBSclearAll       : S := '|10|02-|08- |10D|02e|08lete |10e|02n|08tire |10l|02i|08st? ';
       strEmailUserUnknown  : S := '|12|04-|08- |12U|04s|08er |12n|04o|08t |12f|04o|08und |12-|04-|08-';
       strEmailNoMail       : S := '|12|04-|08- |12Y|04o|08u |12h|04a|08ve |12n|04o |12m|04a|08il |12w|04a|08it'+
                                   'ing |12-|04-|08-';
       strEmailSelectToRead : S := '|15|07-|08- |15B|07e|08gin |15r|07e|08ading |15a|07t |15w|07h|08ich |15m|07'+
                                   'e|08ssage |08[|071|08-|07%S1|08]: |15';
       strEmailReadPrompt   : S := '|08= |15Rea|07di|08ng |15Em|07ai|08l |15%S1 |08of |07%S2 |08 |11Com|03ma|08'+
                                   'nd [|15q|08/|07quit|08|15?|08/|07help|08|15enter|08/|07next|08]: |07';
       strEmailNoAccess     : S := '|15E|07mai|08l |15a|07cces|08s |15d|07enie|08d.';
       strLoginHelpName     : S := '|07Enter your name, handle or user number.';
       strLoginHelpPw       : S := '|07Enter your password.';
       strLoginHelpPhone    : S := '|07Please complete your phone number.';
       strLoginHelpBirth    : S := '|07Enter your birthdate.';
       strLoginHelpApply    : S := '|07Logon to system as a new user?';
       strLoginHelpSysPw    : S := '|07Enter system password.';
       strEmailKillOriginal : S := '|15|07-|08- |15D|07e|08stroy |15o|07r|08ignal |15m|07e|08ssage? ';
       strNuAskState        : S := '|09E|01n|08ter |09y|01o|08ur |09s|01t|08ate/|09p|01r|08ovince |09a|01b|08breviation: |09';
       strMsgSetPointer     : S := '|12|04-|08- |12N|04e|08wscan |12p|04o|08inter |12s|04e|08t |04t|08o |12c|04'+
                                   'u|08rrent |12m|04e|08ssage.';
       strPageAskWhy        : S := '|12-|04-|08- |15En|07te|08r |15ch|07a|08t |15re|07as|08on.|LF: ';
       strPageSysOpNotAvail : S := '|15-|07-|08- |12S|04orr|08y, |12t|04h|08e |12s|04yso|08p |04i|08s |12n|04o|08t |12av|'+
                                   '04ailabl|08e.';
       strPagePaging        : S := '|08[|15p|07ag|08e!|07] ';
       strPageNoAnswer      : S := '|15-|07-|08- |12S|04orr|08y, |12t|04h|08e |12S|04ysO|08p |12c|04ouldn|08''t |12a|04n'+
                                   'swe|08r |12y|04ou|08r |12p|04ag|08e.';
       strEmailAskRead      : S := '|15|07-|08- |15Y|07o|08u |15h|07a|08ve |15e|07m|08ail.  |15R|07e|08ad |07i|08t? ';
       strMsgAskChangeArea  : S := '|12-|04-|08- |15C|07h|08ange |07t|08o |15w|07h|08ich |15m|07e|08ssage |15a|07r|08ea? |07';
       strMsgChangedAreas   : S := '|15-|07-|08- |10C|02u|08rrent |10m|02e|08ssage |10a|02r|08ea |02i|08s |10n|02o|08w |'+
                                   '15%S1|08.';
       strTimeExpired       : S := '|15-|07-|08- |12S|04orr|08y, |12y|04o|08ur |12t|04i|08me |12h|04a|08s |12e|04x|08pired.';
       strMsgAskPointer     : S := '|09-|01-|08- |15E|07nt|08er |15m|07es|08sage |15p|07oi|08nter |15d|07at|08e [|07mm|08'+
                                   '/|07dd|08/|07yy|08]: ';
       strMsgAskAllPointers : S := '|09-|01-|08- |15U|07pd|08ate |15a|07l|08l |15m|07es|08sage |15a|07re|08as? ';
       strXferSelectProtocol: S := '|10|02-|08- |10Se|02lec|08t |10pr|02oto|08col [|15enter|08/|07abort|08]: |10';
       strMsgAskUploadMsg   : S := '|11U|03p|08load |11p|03r|08epared |11m|03e|08ssage? ';
       strAutoSigChanged    : S := '|13-|05-|08- |13Au|05toS|08ig |13sa|05ve|08d.';
       strAutoSigAskDelete  : S := '|13-|05-|08- |13De|05str|08oy |13cu|05rre|08nt |13au|05tos|08ig? ';
       strAutoSigDeleted    : S := '|15-|07-|08- |15Au|07toS|08ig |15de|07let|08ed.';
       strAutoSigShow       : S := '|08--- |11Cu|03rre|08nt |11au|03tos|08ig:|LF|07';
       strAutoSigNone       : S := '|12[|08-|04] |12Y|04ou|08r |12au|04tosi|08g |04i|08s |12bl|04an|08k.';
       strAutoSigAskUpload  : S := '|15|07-|08- |15Up|07loa|08d |15pr|07epar|08ed |15aut|07osignat|08ure? ';
       strMsgScanMandatory  : S := '|08<|15-|07> |09Sc|01anni|08ng |09f|01o|08r |09ma|01ndat|08ory |09me|01ssag|08es ...';
       strEmailSent         : S := '|08- |11Em|03ai|08l |11s|03en|08t |03t|08o |15%S1|08.';
       strEmailAskKillAll   : S := '|08\-/ |15De|07let|08e |15a|07l|08l |15r|07ea|08d |15m|07ai|08l? ';
       strMsgAskPassword    : S := '|14|06-|08- |15En|07te|08r |15me|07ssa|08ge |15a|07re|08a |15pas|07swo|08rd: |07';
       strFaAskPassword     : S := '|14|06-|08- |15En|07te|08r |15f|07il|08e |15a|07re|08a |15pas|07swo|08rd: |07';
       strFaAskChangeArea   : S := '|12-|04-|08- |15C|07h|08ange |07t|08o |15w|07h|08ich |15f|07i|08le |15a|07r|08ea? |07';
       strFaChangedAreas    : S := '|15-|07-|08- |10C|02u|08rrent |10f|02i|08le |10a|02r|08ea |02i|08s |10n|02o|08w |'+
                                   '15%S1|08.';
       strFaNoFilesInArea   : S := '|15-|07-|08- |12S|04orr|08y, |12t|04her|08e |12a|04r|08e |04n|08o |12f|04ile|08s '+
                                   '|04i|08n |12t|04hi|08s |12a|04re|08a.';
       strFaSortStart       : S := '|12|04-|08- |12S|04o|08rting |12a|04r|08ea: |12%S1 |04[|12%S2 |04files|08] ...';
       strFaSortEnd         : S := ' |12c|04o|08mplete.';
       strFaSortAskAll      : S := '|10|02-|08- |10S|02o|08rt |10a|02l|08l |10f|02i|08le |10a|02r|08eas? ';
       strInitBBS           : S := '|CS|08[ |15in|07itializi|08ng |15in|07iqui|08ty ] ...';
       strConfMsgSelect     : S := '|15|07-|08- |09Se|01le|08ct |09me|01ssa|08ge |09co|01nferen|08ce <|15?|08/|07li'+
                                   'st|08  |15enter|08/|07current|08>: |09';
       strConfFileSelect    : S := '|15|07-|08- |09Se|01le|08ct |09f|01il|08e |09co|01nferen|08ce <|15?|08/|07list|08'+
                                   '  |15enter|08/|07current|08>: |09';
       strConfMsgChanged    : S := '|15|07-|08- |15Jo|07in|08ed |15me|07ssa|08ge |15co|07nferen|08ce: |14%S1';
       strConfFileChanged   : S := '|15|07-|08- |15Jo|07in|08ed |15f|07il|08e |15co|07nferen|08ce: |14%S1';
       strNuPausing         : S := '|09U|01s|08e |09s|01c|08reen |09p|01a|08using? ';
       strNuAutoQuote       : S := '|09U|01s|08e |09m|01e|08ssage |09a|01u|08toquote? ';
       strMsgAskQuote       : S := '|11A|03u|08toQuote |11m|03e|08ssage? ';
       strAtchAskDesc       : S := '|15|07-|08- |09E|01nte|08r |09f|01il|08e |09de|01scripti|08on.|LF: |09';
       strAtchFileAttached  : S := '|15|07-|08- |15F|07il|08e |15%S1 |15a|07ttach|08ed.';
       strAtchAlreadyInc    : S := '|15|07-|08- |09F|01il|08e |09a|01lrea|08dy |09a|01ttach|08ed.  |09R|01epla|08ce '+
                                   '|01i|08t? ';
       strAtchIsAttached    : S := '|08-- |09T|01her|08e |01i|08s a |09f|01il|08e |09a|01ttach|08ed |01t|08o |09t|'+
                                   '01hi|08s |09m|01essa|08ge.|LF';
       strAtchShowDesc      : S := '|09  D|01es|08c: |09%S1';
       strAtchShowInfo      : S := '|09  N|01am|08e: |09%S1|LF|09  S|01iz|08e: |09%S2|LF';
       strAtchAskDownload   : S := '|08-- |09W|01oul|08d |09y|01o|08u |09l|01ik|08e |01t|08o |09d|01ownlo|08ad |01i'+
                                   '|08t |09n|01o|08w? ';
       strFaAskFileDownload : S := '|CS|07<|15-|08> |12e|04nte|08r |12f|04ilenam|08e |04t|08o |12d|04ownlo|08ad: |12';
       strFaSearching       : S := '|07<|15-|08> |12s|04earchi|08ng ... ';
       strFaFileNotFound    : S := '|07<|15-|08> |12f|04il|08e |12n|04o|08t |12f|04oun|08d.';
       strFaFoundInArea     : S := '|07<|15-|08> |12%S1 f|04oun|08d |04i|08n |12f|04il|08e |12a|04re|08a: |12%S2';
       strFaFileNotThere    : S := '|07<|15-|08> |12f|04il|08e |12d|04oe|08s |12n|04o|08t |12a|04ctual|08ly |12e|04xis|08t.';
       strFaDownloadPrompt  : S := '|07<|15-|08> |12p|04res|08s |15e|07nter |04t|08o |12d|04ownlo|08ad, |15e|07sc'+
                                   'ape |04t|08o |12a|04bor|08t: |12';
       strFaNoTimeForDL     : S := '|07<|15-|08> |12i|04nsufficie|08nt |12t|04im|08e |12f|04o|08r |12t|04ransf|08er.';
       strFaNewScanning     : S := '|07[|15\|08] |13n|05ewscanni|08ng |13a|05re|08a |07%S1|08  <|02%S2 |10f|02ile|08s> ... ';
       strFaNewScanAskAll   : S := '|15|07-|08- |10N|02e|08wScan |10a|02l|08l |10f|02i|08le |10a|02r|08eas? ';
       strFaAskNewScanDate  : S := '|07[|15\|08] |13e|05nte|08r |13n|05ewsca|08n |13d|05at|08e [|15c|07urren|08t: |07%FD|08'+
                                   ']: |13';
       strFaNoFilePts       : S := '|07<|15-|08> |12i|04nsufficie|08nt |12f|04il|08e |12p|04oint|08s [|15h|07av|08e: |07%S1'+
                                   '|08 - |15r|07equir|08ed: |07%S2|08]';
       strFaOverDLlimit     : S := '|07<|15-|08> |12y|04o|08u |12m|04a|08y |12d|04ownlo|08ad |12o|04nl|08y |07%S1 |12f|04i'+
                                   'le|08s |12p|04e|08r |12d|04a|08y.';
       strFaOverDLkbLimit   : S := '|07<|15-|08> |12y|04o|08u |12m|04a|08y |12d|04ownlo|08ad |12o|04nl|08y |07%S1|08kb |12'+
                                   'p|04e|08r |12d|04a|08y.';
       strFaFileNotValid    : S := '|07<|15-|08> |12t|04hi|08s |12h|04a|08s |12n|04o|08t |12b|04ee|08n |12v|04alidat|08ed'+
                                   ' |12f|04o|08r |12d|04ownlo|08ad.';
       strQwkDLaskCurConf   : S := '|07:|15-|08: |10G|02athe|08r |10m|02sg|08s |10f|02ro|08m |10c|02urren|08t |10c|02onfere'+
                                   'nc|08e |10o|02nl|08y? [|07%CM|08] ';
       strQwkDLerror        : S := '|07:|15-|08: |12q|04w|08k |12d|04ownloa|08d |12e|04rro|08r ...';
       strQwkDLaskDownload  : S := '|07:|15-|08: |10q|02w|08k |10p|02acke|08t |10s|02iz|08e: |15%S1 |10b|02yte|08s ... |1'+
                                   '0d|02ownloa|08d |02i|08t? ';
       strQwkDLnoNewMsgs    : S := '|07:|15-|08: |10s|02orr|08y, |02n|08o |10n|02e|08w |10m|02essage|08s.';
       strQwkDLaskUpdatePtrs: S := '|07:|15-|08: |10u|02pdat|08e |10m|02essag|08e |10n|02ewsca|08n |10p|02ointer|08s? ';
       strQwkDLupdatingPtrs : S := '|07:|15-|08: |10u|02pdatin|08g |10p|02ointer|08s ... |10w|02ai|08t.';
       strQwkULerror        : S := '|07:|15-|08: |12r|04e|08p |12p|04rocessin|08g |12e|04rro|08r ...';
       strMsgPublicPosted   : S := '|U1Message posted in area|U2: |U3%S1';
       strFaAskListFiles    : S := '|U1Enter filespec to list|LF|U5[|U6enter|U5/|U4all|U5] |U1';
       strFaNoMatchingFiles : S := '|U4No matching files found|U5.';
       strQwkULalready      : S := '|U4This |U6REP |U4packet has already been uploaded|U5!';
       strQwkDLownMsgs      : S := '|U1Include |U3your |U1own messages in packet|U2?';
       strFaBatchFull       : S := '|U4Sorry|U5, |U4your download batch is full|U5.';
       strFaBatchAskAdd     : S := '|U1Enter filename to add to batch|U2: |U3';
       strFaBatchAdded      : S := '|U1File |U2"|U3%S1|U2" |U1successfully added to batch|U2.';
       strFaBatchFileDL     : S := '|U1Selected|U2: "|U3%S1|U2"  |U5[|U4size |U5= |U6%S2 |U4bytes|U5, |U4time |U5= |U6%S3|U5]';
       strFaBatchDLtotal    : S := '|U1Total selected|U2: |U6%S1 |U4files|U5, |U6%S2 |U4bytes |U5[|U4time |U5= |U6%S3|U5]';
       strFaBatchAskDL      : S := '|U1Download files in batch |U5[|U6%S1|U4 file|U5(|U4s|U5)] ? ';
       strFaBatchAlready    : S := '|U4That file is already in your download batch|U2.';
       strFaXferFailed      : S := '|U4Transfer failed|U5.';
       strFaXferSuccess     : S := '|U4Transfer successful|U5.';
       strFaXferFilesSent   : S := '|U3%S2 |U1bytes sent in |U3%S1 |U1file|U2(|U1s|U2).';
       strFaListInfo        : S := '|U5-- |U4Listing files |U5- |U3up|U2/|U3down|U2: |U1file selection bar|U2; |U3lef'+
                                   't|U2/|U3right|U2: |U1move menu lightbar';
       strFaListInfoBar     : S := '|U5-- |U4File selector |U5- |U3up|U2/|U3down|U2: |U1select file|U2; |U3left|U2/|U3ri'+
                                   'ght|U2: |U1move menu lightbar';
       strFaViewAskFile     : S := '|U1Enter archive name to view|U2: |U3';
       strFaInfoAskfile     : S := '|U1Show information on which file|U2? |U3';
       strFaULnoAccess      : S := '|U4You do not have upload access in this area|U5.';
       strFaDLnoAccess      : S := '|U4You do not have download access in this area|U5.';
       strFaDLaccessDenied  : S := '|U6%S1|U5: |U4Access denied|U5.';
       strFaTestCRCok       : S := '|U3%S1 |U1passed CRC check|U3.';
       strFaTestCRCfail     : S := '|U6%S1 |U4failed CRC check|U5!';
       strFaTestDecompOk    : S := '|U3%S1 |U1successfully uncompressed|U2.';
       strFaTestDecompFail  : S := '|U4Error while uncompressing |U6%S1|U5!';
       strFaTestVirusOk     : S := '|U1No viruses found in |U3%S1|U2.';
       strFaTestVirusFail   : S := '|U6%S1 |U4failed virus scan|U5!';
       strFaTestAgeOk       : S := '|U3%S1 |U1passed age test|U2.  |U1File|U2 [|U3%S2|U2]';
       strFaTestAgeFail     : S := '|U3%S1 |U1failed age test|U2!  |U1File|U2 [|U3%S2|U2]';
       strFaTestFilesRemoved: S := '|U1Useless files stripped from archive|U2.';
       strFaTestFilesAdded  : S := '|U1BBS advertisments added to file|U2.';
       strFaTestCommented   : S := '|U1File comment added to |U3%S1|U2.';
       strFaTestExternal    : S := '|U1External maintenence complete|U2.';
       strFaTestDescFound   : S := '|U1Found file description|U2.';
       strFaTestNoDesc      : S := '|U4No description found in |U6%S1|U5.';
       strFaTestSauceFound  : S := '|U1Sauce description loaded from |U3%S1|U2.';
       strFaTestNoSauce     : S := '|U6%S1 |U4has not been sauced|U5.';
       strFaTestPassed      : S := '|U3%S1 |U1passed|U2.';
       strFaTestFailed      : S := '|U6%S1 |U4failed|U5.';
       strFaULenterFiles    : S := '|U1Enter the file|U2(|U1s|U2) |U1you wish to upload|U2; |U1max |U3%S1|U2.';
       strFaULenterToEnd    : S := '|U1Press |U2[|U3enter|U2] |U1on a blank line to end|U2.';
       strFaULenterFilename : S := '|U5[|U6%S1|U5@04] |U4Filename|U5: |U6';
       strFaULfileExists    : S := '|U3%S1 |U1is already here|U2!';
       strFaULaskDescNow    : S := '|U1Enter file description|U2(|U1s|U2) |U1now or after upload|U2? ';
       strFaULaddingFile    : S := '|U4Applying |U6%S1 |U4to file area records|U5 ...';
       strFaULfileAdded     : S := '|U6%S1 |U4added |U2[|U3%S2|U1 line description|U2]';
       strFaULdescribe      : S := '|U1Enter description for |U3%S1|U2.  |U1Hit |U3enter |U1on a blank line to end|U2';
       strFaULdescLine      : S := '|U6%S1@03|U5: |U4';
       strFaULDLratioBad    : S := '|U6%S1|U5: |U4Sorry|U5, |U4your UL|U5/|U4DL ratio is out of balance|U5.';
       strFaKBratioBad      : S := '|U6%S1|U5: |U4Sorry|U5, |U4your UL|U5/|U4DL kb ratio is out of balance|U5.';
       strFaLowestArea      : S := '|U4Lowest file area|U5.';
       strFaHighestArea     : S := '|U4Highest file area|U5.';
       strMsgLowestArea     : S := '|U4Lowest message area|U5.';
       strMsgHighestArea    : S := '|U4Highest message area|U5.';
       strInfoAskWhich      : S := '|U1Fill out which infoform|U2? |U5[|U61|U5-|U6%S1|U5] |U4';
       strInfoAskReplace    : S := '|U1You have already completed this infoform|U2.  |U1Redo it|U2? ';
       strNuAskCountry      : S := '|U1Your country? |U6U|U5)|U4nited States|U5; |U6C|U5)|U4anada|U5; |U6O|U5)|U4ther|U5: |U3';
       strNuEnterCountry    : S := '|U1Enter the your country name|U2: ';
       strNuEnterZipCode    : S := '|U1Enter your zip code |U2[|U1format|U2: |U1%S1|U2] |U3';
       strNuAskApply        : S := '|U1Proceed with application process|U2? ';
       strPwAskOld          : S := '|U4Enter current password|U5: |U6';
       strPwWrong           : S := '|U4Password is incorrect|U5.';
       strPwNewPassword     : S := '|U4Enter your new password|U5: |U6';
       strPwTooSmall        : S := '|U4Password must be at least |U64|U4 characters long|U5.';
       strPwValidate        : S := '|U4Re-enter password for verification|U5: |U6';
       strPwNoMatch         : S := '|U4Passwords don''t match|U5.';
       strPwChanged         : S := '|U4Password changed|U5.';
       strPageNoMore        : S := '|U4Sorry|U5, |U4you can''t page the sysop any more this call|U5.';
       strPageAskOverride   : S := '|U4The sysop is not available|U5.  |U4Do you wish to override|U5? ';
       strPageAskPassword   : S := '|U4Enter override password|U5: |U6';
       strPageBadPw         : S := '|U1Incorrect password|U3.';
       strTimeInactive      : S := '|U4Inactivity timeout|U5.  |U4Hanging up|U5 ...';
       strPageBegin         : S := '|U1Paging sysop |U2... |U5(|U4press |U6space |U4to abort|U5)';
       strPageLeaveEmail    : S := '|U1Do you wish to leave email to |U3%S1|U2? ';
       strFaSearchAskFile   : S := '|U5(|U4search|U5) |U1Enter filespec|U2: |U3';
       strFaSearchAskAll    : S := '|U5(|U4search|U5) |U1Scan all file areas|U2? ';
       strFaSearchAskConfs  : S := '|U5(|U4search|U5) |U1Scan all conferences|U2? ';
       strFaSearchArea      : S := '         |U1Searching |U3%S1|U2 ...';
       strFaSearchNone      : S := '|U5(|U4search|U5) |U1Sorry|U2, |U1no matching files were found|U2.';
       strFaULfileFound     : S := '|U1Found |U3%S1|U2 ...';
       strFaULaskBlind      : S := '|U1Blind upload|U2? ';
       strNuvScanning       : S := '|U5[|U4nuv|U5] |U1Scanning for new users |U2...';
       strNuvVote           : S := '|U1Should |U3%S1 |U1exist on this bbs|U2? |U5[|U6y|U5)|U4es |U6n|U5)|U'+
                                   '4o |U6a|U5)|U4bstain|U5 |U6i|U5)|U4forms|U5] |U3';
       strNuvAskComment     : S := '|U1Leave a comment|U2? ';
       strNuvComment        : S := '|U1Enter comment|U2: |U3';
       strNuvValidated      : S := '|U4User |U6validated|U5!';
       strNuvDeleted        : S := '|U4User |U6terminated|U5.';
       strNuvNoInfoforms    : S := '|U1This user has not completed any newuser infoforms|U2.';
       strNuvIsDisabled     : S := '|U1New user voting is not used on this BBS';
       strFaSearchAskDesc   : S := '|U5(|U4search|U5) |U1Enter text to search for|U2: |U3';
       strNuvNone           : S := '|U1No new users to vote on|U2.';
       strNodeNotMulti      : S := '|U4This is |U6not |U4a multi-node BBS|U5.';
   end;
   resetString := s;
end;

procedure resetMessage;
begin
   with Msg^ do
   begin
      with FromInfo do
      begin
         UserNum := 1;
         Alias := 'Unknown';
         RealName := 'None';
         Name := 'None';
         UserNote := 'None';
      end;
      with ToInfo do
      begin
         UserNum := 1;
         Alias := 'Unknown';
         RealName := 'None';
         Name := 'None';
         UserNote := 'None';
      end;
      Pos := 1;
      Size := 0;
      Date := dtDateTimePacked;
      Status := [];
      Replies := 0;
      Subject := 'Untitled';
   end;
end;

procedure initVariables;
var Z : String;
begin
   New(User);
   New(Modem);
   New(strBuf);
   New(Menu);
   New(Cmd);
   New(mArea);
   New(Msg);
   New(Scan);
   New(ioWin);
   New(Stat);
   New(His);
   New(fArea);
   New(mConf);
   New(fConf);
   New(Prot);
   New(textLib);
   New(nodeInfo);

   FillChar(User^,SizeOf(User^),0);
   FillChar(Modem^,SizeOf(Modem^),0);
   FillChar(strBuf^,SizeOf(strBuf^),0);
   FillChar(Menu^,SizeOf(Menu^),0);
   FillChar(Cmd^,SizeOf(Cmd^),0);
   FillChar(mArea^,SizeOf(mArea^),0);
   FillChar(Msg^,SizeOf(Msg^),0);
   FillChar(Scan^,SizeOf(Scan^),0);
   FillChar(ioWin^,SizeOf(ioWin^),0);
   FillChar(Stat^,SizeOf(Stat^),0);
   FillChar(His^,SizeOf(His^),0);
   FillChar(fArea^,SizeOf(fArea^),0);
   FillChar(mConf^,SizeOf(mConf^),0);
   FillChar(fConf^,SizeOf(fConf^),0);
   FillChar(Prot^,SizeOf(Prot^),0);
   FillChar(textLib^,SizeOf(textLib^),0);
   FillChar(nodeInfo^,SizeOf(nodeInfo^),0);

   FillChar(strIdx,SizeOf(strIdx),0);

   GetDir(0,StartDir);
   if StartDir[Length(StartDir)] <> '\' then StartDir := StartDir+'\';

   resetVariables(True);
   mWriteInit('analyzing node information');

   Node := 1;
   Z := mGetParam(paramNodeNum);
   if Z <> '' then Node := strToInt(Z);
   if (not MultiNode) or (Node < 1) or (Node > maxNode) then Node := 1;
   nodeInit;

   scrInitPages(2);

   ErrorLevel := errNormal;
   posX := 1;
   posY := 1;
   mWriteInit('detecting computer hardware');
   detProcessor;
   detVideoCard;
   detOperator;
{  sndPort := detUltraSound;
   if sndPort <> 0 then sndType := sndUltraSound else detAnySoundBlaster;
   if sndType = sndNone then if detAdlib then sndType := sndAdlib;}
end;

procedure initPaths;
begin
   fCreateDir(Cfg^.pathData,True);
   fCreateDir(Cfg^.pathText,True);
   fCreateDir(Cfg^.pathArch,True);
   mWriteInit('analyzing paths ....');
   fCreateDir(Cfg^.pathMenu,True);
   fCreateDir(Cfg^.pathMsgs,True);
   fCreateDir(Cfg^.pathSwap,True);
   fCreateDir(Cfg^.pathAtch,True);
   mWriteInit('analyzing paths ......');;
   fCreateDir(Cfg^.pathDoor,True);
   fCreateDir(Cfg^.pathProt,True);
   fCreateDir(Cfg^.pathTemp,True);
   fCreateDir(Cfg^.pathDnld,True);
   mWriteInit('analyzing paths ........');;
   fCreateDir(Cfg^.pathLogs,True);
   fCreateDir(Cfg^.pathLibs,True);
   fCreateDir(Cfg^.qwkLocalPath,True);
end;

procedure resetProtocols;
var F : file of tProtRec; P : tProtRec; N : Word;
begin
   Assign(F,Cfg^.pathData+fileProt);
   {$I-}
   Rewrite(F);
   {$I+}
   if ioResult <> 0 then Exit;
   N := 0;
   repeat
      Inc(N,1);
      FillChar(P,SizeOf(P),0);
      with P do
      begin
         Desc := 'Unused';
         Key  := 'X';
         codeIs := 1;
         posFile := 1;
         posStat := 1;
      end;
      case N of
         1 : with P do
             begin
                Desc      := 'Xmodem';
                Flag      := [protActive];
                Key       := 'X';
                Log       := '%TD\DSZLOG.%ND';
                cmdUL     := 'dsz port %CP speed %BR rx %FN';
                cmdDL     := 'dsz port %CP speed %BR sx %FN';
                cmdEnv    := 'SET DSZLOG=%LF';
                codeUL[1] := 'R';
                codeUL[2] := 'r';
                codeUL[3] := '';
                codeUL[4] := '';
                codeUL[5] := '';
                codeUL[6] := '';
                codeDL[1] := 'S';
                codeDL[2] := 's';
                codeDL[3] := '';
                codeDL[4] := '';
                codeDL[5] := '';
                codeDL[6] := '';
                codeIs    := xferOk;
                posFile   := 51;
                posStat   := 1;
             end;
         2 : with P do
             begin
                Desc      := 'Ymodem';
                Flag      := [protActive];
                Key       := 'Y';
                Log       := '%TD\DSZLOG.%ND';
                cmdUL     := 'dsz port %CP speed %BR rb %FN';
                cmdDL     := 'dsz port %CP speed %BR sb %FN';
                cmdEnv    := 'SET DSZLOG=%LF';
                codeUL[1] := 'R';
                codeUL[2] := 'r';
                codeUL[3] := '';
                codeUL[4] := '';
                codeUL[5] := '';
                codeUL[6] := '';
                codeDL[1] := 'S';
                codeDL[2] := 's';
                codeDL[3] := '';
                codeDL[4] := '';
                codeDL[5] := '';
                codeDL[6] := '';
                codeIs    := xferOk;
                posFile   := 51;
                posStat   := 1;
             end;
         3 : with P do
             begin
                Desc      := 'Ymodem';
                Flag      := [protActive,protBatch];
                Key       := 'Y';
                Log       := '%TD\DSZLOG.%ND';
                cmdUL     := 'dsz port %CP speed %BR rb';
                cmdDL     := 'dsz port %CP speed %BR sb @%FL';
                cmdEnv    := 'SET DSZLOG=%LF';
                codeUL[1] := 'R';
                codeUL[2] := 'r';
                codeUL[3] := '';
                codeUL[4] := '';
                codeUL[5] := '';
                codeUL[6] := '';
                codeDL[1] := 'S';
                codeDL[2] := 's';
                codeDL[3] := '';
                codeDL[4] := '';
                codeDL[5] := '';
                codeDL[6] := '';
                codeIs    := xferOk;
                listDL    := '%TD\BATCH%ND.LST';
                posFile   := 51;
                posStat   := 1;
             end;
         4 : with P do
             begin
                Desc      := 'Ymodem-G';
                Flag      := [protActive];
                Key       := 'G';
                Log       := '%TD\DSZLOG.%ND';
                cmdUL     := 'dsz port %CP speed %BR rb -g %FN';
                cmdDL     := 'dsz port %CP speed %BR sb -g %FN';
                cmdEnv    := 'SET DSZLOG=%LF';
                codeUL[1] := 'R';
                codeUL[2] := 'r';
                codeUL[3] := '';
                codeUL[4] := '';
                codeUL[5] := '';
                codeUL[6] := '';
                codeDL[1] := 'S';
                codeDL[2] := 's';
                codeDL[3] := '';
                codeDL[4] := '';
                codeDL[5] := '';
                codeDL[6] := '';
                codeIs    := xferOk;
                posFile   := 51;
                posStat   := 1;
             end;
         5 : with P do
             begin
                Desc      := 'Zmodem';
                Flag      := [protActive];
                Key       := 'Z';
                Log       := '%TD\DSZLOG.%ND';
                cmdUL     := 'dsz ha on port %CP speed %BR pB2048 pR1 rz -Z -m -rr %FN';
                cmdDL     := 'dsz ha on port %CP speed %BR sz -m %FN';
                cmdEnv    := 'SET DSZLOG=%LF';
                codeUL[1] := 'Z';
                codeUL[2] := 'z';
                codeUL[3] := '';
                codeUL[4] := '';
                codeUL[5] := '';
                codeUL[6] := '';
                codeDL[1] := 'Z';
                codeDL[2] := 'z';
                codeDL[3] := '';
                codeDL[4] := '';
                codeDL[5] := '';
                codeDL[6] := '';
                codeIs    := xferOk;
                posFile   := 51;
                posStat   := 1;
             end;
         6 : with P do
             begin
                Desc      := 'Zmodem';
                Flag      := [protActive,protBatch];
                Key       := 'Z';
                Log       := '%TD\DSZLOG.%ND';
                cmdUL     := 'dsz ha on port %CP speed %BR pB2048 pR1 rz -Z -m -rr';
                cmdDL     := 'dsz ha on port %CP speed %BR sz -m @%FL';
                cmdEnv    := 'SET DSZLOG=%LF';
                codeUL[1] := 'Z';
                codeUL[2] := 'z';
                codeUL[3] := '';
                codeUL[4] := '';
                codeUL[5] := '';
                codeUL[6] := '';
                codeDL[1] := 'Z';
                codeDL[2] := 'z';
                codeDL[3] := '';
                codeDL[4] := '';
                codeDL[5] := '';
                codeDL[6] := '';
                codeIs    := xferOk;
                listDL    := '%TD\BATCH%ND.LST';
                posFile   := 51;
                posStat   := 1;
             end;
         7 : with P do
             begin
                Desc      := 'Hydra';
                Flag      := [protActive,protBiDir];
                Key       := 'H';
                Log       := '%TD\DSZLOG.%ND';
                cmdUL     := 'HYDRACOM port %CP speed %BR ha hard Get';
                cmdDL     := 'HYDRACOM port %CP speed %BR ha hard Send %FL';
                cmdEnv    := 'SET DSZLOG=%LF';
                codeUL[1] := 'R';
                codeUL[2] := 'r';
                codeUL[3] := 'H';
                codeUL[4] := 'h';
                codeUL[5] := '';
                codeUL[6] := '';
                codeDL[1] := 'H';
                codeDL[2] := 'h';
                codeDL[3] := '';
                codeDL[4] := '';
                codeDL[5] := '';
                codeDL[6] := '';
                codeIs    := xferOk;
                posFile   := 51;
                posStat   := 1;
             end;
         8 : with P do
             begin
                Desc      := 'Hydra';
                Flag      := [protActive,protBatch,protBiDir];
                Key       := 'H';
                Log       := '%TD\DSZLOG.%ND';
                cmdUL     := 'HYDRACOM Port %CP Speed %BR ha hard Get';
                cmdDL     := 'HYDRACOM Port %CP Speed %BR ha hard Send @%FL';
                cmdEnv    := 'SET DSZLOG=%LF';
                codeUL[1] := 'R';
                codeUL[2] := 'r';
                codeUL[3] := 'h';
                codeUL[4] := '';
                codeUL[5] := '';
                codeUL[6] := '';
                codeDL[1] := 'H';
                codeDL[2] := 'h';
                codeDL[3] := '';
                codeDL[4] := '';
                codeDL[5] := '';
                codeDL[6] := '';
                codeIs    := xferOk;
                listDL    := '%TD\BATCH%ND.LST';
                posFile   := 51;
                posStat   := 1;
             end;
         9 : with P do
             begin
                Desc      := 'HS/Link';
                Flag      := [protActive,protBiDir];
                Key       := 'S';
                Log       := '%TD\DSZLOG.%ND';
                cmdUL     := 'HSLINK -P%CP -B%BR -U%DP -O -R';
                cmdDL     := 'HSLINK -P%CP -B%BR -U%DP -O -R %FN';
                cmdEnv    := 'SET DSZLOG=%LF';
                codeUL[1] := 'H';
                codeUL[2] := 'h';
                codeUL[3] := '';
                codeUL[4] := '';
                codeUL[5] := '';
                codeUL[6] := '';
                codeDL[1] := 'H';
                codeDL[2] := 'h';
                codeDL[3] := '';
                codeDL[4] := '';
                codeDL[5] := '';
                codeDL[6] := '';
                codeIs    := xferOk;
                posFile   := 51;
                posStat   := 1;
             end;
        10 : with P do
             begin
                Desc      := 'HS/Link';
                Flag      := [protActive,protBatch,protBiDir];
                Key       := 'S';
                Log       := '%TD\DSZLOG.%ND';
                cmdUL     := 'HSLINK -P%CP -B%BR -U%DP -O -R';
                cmdDL     := 'HSLINK -P%CP -B%BR -U%DP -O -R @%FL';
                cmdEnv    := 'SET DSZLOG=%LF';
                codeUL[1] := 'H';
                codeUL[2] := 'h';
                codeUL[3] := '';
                codeUL[4] := '';
                codeUL[5] := '';
                codeUL[6] := '';
                codeDL[1] := 'H';
                codeDL[2] := 'h';
                codeDL[3] := '';
                codeDL[4] := '';
                codeDL[5] := '';
                codeDL[6] := '';
                codeIs    := xferOk;
                listDL    := '%TD\BATCH%ND.LST';
                posFile   := 51;
                posStat   := 1;
             end;
        11 : with P do
             begin
                Desc      := 'vFast';
                Flag      := [protActive];
                Key       := 'V';
                Log       := '%TD\DSZLOG.%ND';
                cmdUL     := 'VFAST -B%BR -P%CP -R %FN';
                cmdDL     := 'VFAST -B%BR -P%CP -S %FN';
                cmdEnv    := 'SET DSZLOG=%LF';
                codeUL[1] := 'V';
                codeUL[2] := 'v';
                codeUL[3] := '';
                codeUL[4] := '';
                codeUL[5] := '';
                codeUL[6] := '';
                codeDL[1] := 'V';
                codeDL[2] := 'v';
                codeDL[3] := '';
                codeDL[4] := '';
                codeDL[5] := '';
                codeDL[6] := '';
                codeIs    := xferOk;
                posFile   := 51;
                posStat   := 1;
             end;
        12 : with P do
             begin
                Desc      := 'vFast';
                Flag      := [protActive,protBatch];
                Key       := 'V';
                Log       := '%TD\DSZLOG.%ND';
                cmdUL     := 'VFAST -B%BR -P%CP -R';
                cmdDL     := 'VFAST -B%BR -P%CP -S @%FL';
                cmdEnv    := 'SET DSZLOG=%LF';
                codeUL[1] := 'V';
                codeUL[2] := 'v';
                codeUL[3] := '';
                codeUL[4] := '';
                codeUL[5] := '';
                codeUL[6] := '';
                codeDL[1] := 'V';
                codeDL[2] := 'v';
                codeDL[3] := '';
                codeDL[4] := '';
                codeDL[5] := '';
                codeDL[6] := '';
                codeIs    := xferOk;
                listDL    := '%TD\BATCH%ND.LST';
                posFile   := 51;
                posStat   := 1;
             end;
        13 : with P do
             begin
                Desc      := 'iCE-Zmodem';
                Flag      := [protActive];
                Key       := 'I';
                Log       := '%TD\DSZLOG.%ND';
                cmdUL     := 'IZM Port %CP Speed %BR rz %FN';
                cmdDL     := 'IZM Port %CP Speed %BR sz %FN';
                cmdEnv    := 'SET DSZLOG=%LF';
                codeUL[1] := 'I';
                codeUL[2] := 'i';
                codeUL[3] := '';
                codeUL[4] := '';
                codeUL[5] := '';
                codeUL[6] := '';
                codeDL[1] := 'I';
                codeDL[2] := 'i';
                codeDL[3] := '';
                codeDL[4] := '';
                codeDL[5] := '';
                codeDL[6] := '';
                codeIs    := xferOk;
                posFile   := 51;
                posStat   := 1;
             end;
        14 : with P do
             begin
                Desc      := 'iCE-Zmodem';
                Flag      := [protActive,protBatch];
                Key       := 'I';
                Log       := '%TD\DSZLOG.%ND';
                cmdUL     := 'IZM Port %CP Speed %BR rz';
                cmdDL     := 'IZM Port %CP Speed %BR sz @%FL';
                cmdEnv    := 'SET DSZLOG=%LF';
                codeUL[1] := 'I';
                codeUL[2] := 'i';
                codeUL[3] := '';
                codeUL[4] := '';
                codeUL[5] := '';
                codeUL[6] := '';
                codeDL[1] := 'I';
                codeDL[2] := 'i';
                codeDL[3] := '';
                codeDL[4] := '';
                codeDL[5] := '';
                codeDL[6] := '';
                codeIs    := xferOk;
                listDL    := '%TD\BATCH%ND.LST';
                posFile   := 51;
                posStat   := 1;
             end;
      end;
      Write(F,P);
   until N = maxProt;
   Close(F);
end;

procedure resetArchivers;
var F : file of tArchiverRec; A : tArchiverRec; N : Word;
begin
   Assign(F,Cfg^.pathData+fileArchiver);
   {$I-}
   Rewrite(F);
   {$I+}
   if ioResult <> 0 then Exit;
   N := 0;
   repeat
      Inc(N,1);
      FillChar(A,SizeOf(A),0);
      case N of
         1 : with A do
             begin
                Active     := True;
                Extension  := 'ZIP';
                fileSig    := 'PK^003^004';
                cmdZip     := 'PKZIP -rpa -ex %AF %FN';
                cmdUnZip   := 'PKUNZIP -do %AF %FN';
                cmdTest    := 'PKUNZIP -t %AF';
                cmdComment := 'PKZIP -z %AF < %CF';
                cmdDelete  := 'PKZIP -d %AF %FN';
                listChar   := '@';
                Viewer     := 2;
                okErrLevel := 0;
                CheckEL    := True;
             end;
         2 : with A do
             begin
                Active     := True;
                Extension  := 'ARJ';
                fileSig    := '`';
                cmdZip     := 'ARJ a -rp %AF %FN';
                cmdUnZip   := 'ARJ x -y %AF %FN';
                cmdTest    := 'ARJ t %AF';
                cmdComment := 'ARJ c %AF -z%CF';
                cmdDelete  := 'ARJ d %AF %FN';
                listChar   := '!';
                Viewer     := 1;
                okErrLevel := 0;
                CheckEL    := True;
             end;
         3 : with A do
             begin
                Active     := False;
                Extension  := 'LZH';
                fileSig    := '';
                cmdZip     := 'LHA a /rp %AF %FN';
                cmdUnZip   := 'LHA x /xmrp %AF %FN';
                cmdTest    := 'LHA t %AF';
                cmdComment := '';
                cmdDelete  := 'LHA d %AF %FN';
                listChar   := '@';
                Viewer     := 1;
                okErrLevel := 0;
                CheckEL    := True;
             end;
         else A.Viewer := 1;
      end;
      Write(F,A);
   until N = maxArchiver;
   Close(F);
end;

procedure killVariables;
begin
   Dispose(Cfg);
   Dispose(User);
   Dispose(Modem);
   Dispose(strBuf);
   Dispose(Menu);
   Dispose(Cmd);
   Dispose(mArea);
   Dispose(Msg);
   Dispose(Scan);
   Dispose(ioWin);
   Dispose(Stat);
   Dispose(His);
   Dispose(fArea);
   Dispose(mConf);
   Dispose(fConf);
   Dispose(Prot);
   Dispose(textLib);
   Dispose(nodeInfo);
   scrDeInitPages;
end;

procedure killTerminateBBS;
var S : String; N : Byte;
begin
   ModemIO := not ModemOff;
   logWrite('>'+bbsTitle+' v'+bbsVersion+' terminated (errorlevel '+St(errorLevel)+').');
   ioScreenOn;
   TextAttr := $07;
   TextMode(Co80);
   S := bbsVerLong;
   while Pos(' ',S) > 0 do
   begin
      N := Pos(' ',S);
      Delete(S,N,1);
      Insert(#255'|09',S,N);
      Insert('|01',S,N+5);
   end;
   cFwrite(1,1,'|08'#16+' |08:|15i|07niquity|08: |09v|01'+S+
               ' |09t|01erminated|08; |07e|08rrorlevel |07'+St(ErrorLevel)+'|08.');
   TextAttr := $07;
   GotoXY(1,1);
   {$I-}
   Close(strFile);
   {$I+}
   fNoLibrary;
   fKillDir(fTempPath('-'));
   nodeDone;
   GotoXY(1,23);
   ClrEol;
   mCursor(True);
   cTerminateFossil;
   killVariables;
   {$I-}
   ChDir(strBkSlash(False,StartDir));
   {$I+}
   mCursor(True);
   Halt(ErrorLevel);
end;

procedure initParameters;
var Quit : Boolean;
begin
   asDoor := False;
   if ParamCount = 0 then Exit;
   Quit := False;
   LocalIO := True;
   ModemIO := False;
   HangUp := False;
   HungUp := False;
   UserOn := False;
   QuitAfter := mParam(paramQuitAfter);
   asDoor := ((Cfg^.iniqAsDoor) or (mParam(paramAsDoor))) and (QuitAfter);
   if mParam(paramPackAreas) then
   begin
      mClearScr(True);
      maUpdateAllScanFiles;
      maPackAreas(True,0);
      Quit := True;
   end;
   if mParam(paramSortFiles) then
   begin
      mClearScr(True);
      fsSortFileAreas('A');
      Quit := True;
   end;
   if mParam(paramModemConfig) then
   begin
      mClearScr(True);
      cfgCommunicationsSetup;
      Quit := True;
   end;
   if mParam(paramSystemConfig) then
   begin
      mClearScr(True);
      cfgSystemConfig;
      Quit := True;
   end;
   if mParam(paramMenuEdit) then
   begin
      mClearScr(True);
      cfgMenuEditor;
      Quit := True;
   end;
   if mParam(paramUserEdit) then
   begin
      mClearScr(True);
      cfgUserEditor(1);
      Quit := True;
   end;
   if mParam(paramStringEdit) then
   begin
      mClearScr(True);
      cfgStringEditor;
      Quit := True;
   end;
   ModemIO := not ModemOff;
   if Quit then killTerminateBBS;
end;

function ModemFile : String;
var P : String; Ps : Byte;
begin
   P := fileModem;
   Ps := Pos('%',P);
   if Ps < 1 then Exit;
   Delete(P,Ps,1);
   Insert(St(Node),P,Ps);
   ModemFile := Cfg^.pathData+P;
end;

procedure initFiles;
var fCfg : file of tCfgRec;
    fModem : file of tModemRec;
    fUsers : file of tUserRec;
    fMArea : file of tMsgAreaRec;
    fFArea : file of tFileAreaRec;
    fTlib : file of tTextLibRec;
    fInfo : file of tInfoformRec;
    S : String;
    fixStrs : Boolean;
begin
   mWriteInit('analyzing paths ..');
   initPaths;
   mWriteInit('checking modem/node config');
   Assign(fModem,ModemFile);
   {$I-} Reset(fModem); {$I+}
   if ioResult <> 0 then fResetModem(1);
   mWriteInit('reading modem setup');
   {$I-} Read(fModem,Modem^); {$I+}
   if ioResult <> 0 then fResetModem(1) else Close(fModem);

   Assign(fUsers,Cfg^.pathData+fileUsers);
   {$I-} Reset(fUsers); {$I+}
   if ioResult <> 0 then
   begin
      userReset;
      userAdd(User^);
      numUsers := 1;
   end else
   begin
      {$I-} Read(fUsers,User^); {$I+}
      if ioResult <> 0 then
      begin
         Close(fUsers);
         userReset;
         Rewrite(fUsers);
         Write(fUsers,User^);
      end;
      numUsers := FileSize(fUsers);
      Close(fUsers);
   end;
   mWriteInit('analyzing user index');
   userCheckIndex;
   mWriteInit('checking protocols');
   if not fExists(cfg^.pathData+fileProt) then resetProtocols;
   mWriteInit('initializing string cache');
   Assign(strFile,Cfg^.pathData+fileStrings);
   {$I-}
   Reset(strFile,256);
   {$I+}
   fixStrs := False;
   if ioResult <> 0 then
   begin
      {$I-}
      Rewrite(strfile,256);
      {$I+}
      if ioResult = 0 then fixStrs := True;
   end else if fileSize(strFile) < numString then fixStrs := True;

   if fixStrs then
   begin
      Seek(strFile,0);
      while not eof(strFile) do
      begin
         BlockRead(strFile,s,1);
         if cleanUp(s) = '' then
         begin
            Seek(strFile,filePos(strFile)-1);
            s := resetString(filePos(strfile)+1);
            BlockWrite(strFile,s,1);
         end;
      end;
      while fileSize(strFile) < numString do
      begin
         s := resetString(filePos(strfile)+1);
         BlockWrite(strFile,s,1);
      end;
   end;
   mWriteInit('checking msg areas');
   Assign(fMArea,Cfg^.pathData+fileMsgArea);
   {$I-}
   Reset(fMArea);
   {$I+}
   if ioResult <> 0 then
   begin
      maReset;
      Rewrite(fMArea);
      Write(fMArea,mArea^);
      Close(fMArea);
      numMsgArea := 1;
   end else
   begin
      Read(fMArea,mArea^);
      numMsgArea := FileSize(fMArea);
      Close(fMArea);
   end;
   mWriteInit('checking file areas');
   Assign(fFArea,Cfg^.pathData+fileFileArea);
   {$I-}
   Reset(fFArea);
   {$I+}
   mWriteInit('loading area info');
   if ioResult <> 0 then
   begin
      faReset;
      Rewrite(fFArea);
      Write(fFArea,fArea^);
      Close(fFArea);
      numFileArea := 1;
   end else
   begin
      Read(fFArea,fArea^);
      numFileArea := FileSize(fFArea);
      Close(fFArea);
   end;
   mWriteInit('checking text libraries');

   Assign(fTlib,Cfg^.pathData+fileTextLib);
   {$I-}
   Reset(fTlib);
   {$I+}
   if ioResult = 0 then
   begin
      numLib := fileSize(fTlib);
      Close(fTlib);
   end else numLib := 0;
   mWriteInit('checking infoforms');

   Assign(fInfo,Cfg^.pathData+fileInfoform);
   {$I-}
   Reset(fInfo);
   {$I+}
   if ioResult = 0 then
   begin
      numInfo := fileSize(fInfo);
      Close(fInfo);
   end else numInfo := 0;
   mWriteInit('checking prots/archs');

   if not fExists(Cfg^.pathData+fileProt) then resetProtocols;
   if not fExists(Cfg^.pathData+fileArchiver) then resetArchivers;
   mWriteInit('loading system stats');
end;

procedure initCommPort;
var s : string;
begin
   s := mGetParam(paramOnlineBaud);
   ModemOff := (Modem^.ComPort = 4) or (mParam(paramNoModemIO)) or (s = '0');
   ModemIO := not ModemOff;

   if not cFossilInstalled then
   begin
      logWrite('xFOSSIL driver not detected');
      ioClrScr;
      WriteLn;
      WriteLn(bbsTitle+' requires a FOSSIL communications driver.  Please ensure');
      WriteLn('that a compatible driver is installed before attempting to load '+bbsTitle);
      Halt(errFatal);
   end;
   mWriteInit('initializing fossil');
   if not cSetupCommunications then
   begin
      logWrite('xError initializing comport (COM'+St(Modem^.ComPort+1)+')');
      ioClrScr;
      WriteLn;
      WriteLn(bbsTitle+' encountered an error while attempting to initialize the');
      WriteLn('communications port.  Please ensure that '+bbsTitle+'''s modem setup');
      WriteLn('for this node is configured properly (currently COM'+st(Modem^.ComPort+1)+')');
      Halt(errFatal);
   end;
end;

end.