{$F-,A+,O+,G+,R-,S+,I+,Q-,V-,B-,X+,T-,P-,D-,L-,N-,E+}
unit Strings;

interface

uses Global;

function B2St(B : Boolean) : String;
function CenterPos(S : String) : Integer;
function ChPos(C : Char; S : String) : Byte;
function CleanUp( str : String ) : String;
function DateString : String;
function LowCase(C : Char) : Char;
function NoColor(o : String) : String;
function Resize(S : String; L : Integer) : String;
function ResizeRt(S : String; L : Integer) : String;
function sRepeat(C : Char; N : Byte) : String;
function St(N : LongInt) : String;
function Stc(I : LongInt) : String;
function strBkSlash(B : Boolean; S : String) : String;
function strCenter(S : String; Len : Integer) : String;
function strCode(S : String; N : Byte; Ins : String) : String;
function strColCode(fC,bC : Byte; bL : Boolean) : String;
function strColor(C : tColorRec) : String;
function strColorName(C : Byte) : String;
function strEcho(S : String) : String;
function strEnlarge(S : String; Len : Byte) : String;
function strFileExt(Fn : String) : String;
function strFilename(S : String) : String;
function strHex(a : Word; b : Byte) : String;
function strIsNum(N, I : LongInt; S : String) : String;
function strIsWild(S : String) : Boolean;
function strLow(s : String) : String;
function strMixed(S : String) : String;
function strReal(R : Real; Ch, Dc : Byte) : String;
function strReplace(S, Find, Rep : String) : String;
function strResizeNc(S : String; L : Byte) : String;
function strSquish(S : String; L : Byte) : String;
function strToInt(S : String) : LongInt;
function strWierd(S : String) : String;
function strWildCard(S1,S2 : String) : Boolean;
function TimeString : String;
function UpStr(S : String) : String;
function z2(n : Word) : String;
function z3(n : Word) : String;

implementation

uses Dos;

function sRepeat(C : Char; N : Byte) : String;
var L : Byte; S : String;
begin
   S := '';
   for L := 1 to N do S := S + C;
   sRepeat := S;
end;

function strIsNum(N, I : LongInt; S : String) : String;
begin
   if N = I then strIsNum := S else strIsNum := St(N);
end;

function ChPos(C : Char; S : String) : Byte;
var N : Byte;
begin
   N := 0;
   repeat
      Inc(N,1);
   until (N > Length(S)) or (S[N] = C);
   if N > Length(S) then N := 0;
   ChPos := N;
end;
{
function NoColor(o : String) : String;
var S : String; Z : Byte; OK : Boolean;
begin
   S := o;

   while (ChPos(#3,S) > 0) do Delete(S,ChPos(#3,S),2);
   while ChPos('^',S) > 0 do Delete(S,ChPos('^',S),2);

   while ChPos('|',S) > 0 do
   begin
      Z := ChPos('|',S);
      OK := False;
      if (Length(S) >= Z+2) and (S[Z+1] in ['0'..'9']) and (S[Z+2] in ['0'..'9']) then OK := True;
      if OK then Delete(S,Z,3);
   end;
   NoColor := S;
end;
}
function NoColor(o : String) : String;
var S : String; Z : Byte; OK : Boolean;
begin
   Z := 1;
   S := O;
   while Z <= Length(S) do
   begin
      if (S[Z] = '|') and
         (Length(S) >= Z+2) and
         (UpCase(S[Z+1]) in ['0'..'9','U','B']) and
         (S[Z+2] in ['0'..'9']) then Delete(S,Z,3) else
      Inc(Z);
   end;
   NoColor := S;
end;


function StrToInt(S : String) : LongInt;
var i : LongInt;
    j : Integer;
begin
  Val(S,I,J);
  if (j <> 0) then
  begin
    s := Copy(s,1,j-1);
    Val(s,i,j)
  end;
  StrToInt := i;
  if (s = '') then StrToInt := 0;
end;

function Resize(S : String; L : Integer) : String;
begin
   while Length(NoColor(S)) < L do S := S + ' ';
   while Length(NoColor(S)) > L do Dec(S[0]);
   Resize := S;
end;

function strResizeNc(S : String; L : Byte) : String;
begin
   if Length(S) > L then S[0] := Chr(L) else
   if Length(S) < L then
   begin
      FillChar(S[Length(S)+1],L-Length(S),#32);
      S[0] := Chr(L);
   end;
   strResizeNc := S;
end;

function ResizeRt(S : String; L : Integer) : String;
begin
   while Length(NoColor(S)) > L do Delete(S,Length(S),1);
   while Length(NoColor(S)) < L do Insert(' ',S,1);
   ResizeRt := S;
end;

function CenterPos(S : String) : Integer;
begin
   CenterPos := 39 - (Length(NoColor(S)) div 2);
end;

function B2St(B : Boolean) : String;
begin
   if B then B2St := 'Yes' else B2St := 'No';
end;
{
function StrToInt(S : String) : LongInt;
var N : LongInt; Err : Integer;
begin
   Val(S, N, Err);
   StrToInt := N;
end;
}
function DateString : String;
var Year, Month, Day, DOW : Word;
begin
   GetDate(Year, Month, Day, DOW);
   Dec(Year,1900);
   DateString := St(Month)+'/'+St(Day)+'/'+St(Year);
end;

function TimeString : String;
var Hour, Min, Sec, HS    : Word;
begin
   GetTime(Hour, Min, Sec, HS);
   TimeString := St(Hour)+':'+St(Min);
end;

function UpStr(S : String) : String;
var N : Integer;
begin
   for N := 1 to Length(S) do S[N] := UpCase(S[N]);
   UpStr := S;
end;

function LowCase(C : Char) : Char;
begin
   if ('A' <= C) and (C <= 'Z') then LowCase := Chr(Ord(C)+32) else
                                     LowCase := C;
end;

function St(N : LongInt) : String;
var S : String;
begin
   System.Str(N, S);
   St := S;
end;

function LTrim(s : String; c: CHAR ) : String; Assembler;
asm
      PUSH   DS
      LDS    SI, s
      XOR    AX, AX
      LODSB
      XCHG   AX, CX
      LES    DI, @Result
      INC    DI
      JCXZ   @@2

      MOV    BL, c
      CLD
@@1:  LODSB
      CMP    AL, BL
      LOOPE  @@1
      DEC    SI
      INC    CX
      REP    MOVSB

@@2:  XCHG   AX, DI
      MOV    DI, WORD PTR @Result
      SUB    AX, DI
      DEC    AX
      STOSB
      POP    DS
end;

function RTrim( s: String; c: CHAR ): String;
begin
   while (LENGTH(s) > 0) and (s[LENGTH(s)] = c) do DEC(s[0]);
   RTrim := s;
end;

function CleanUp( str : String ) : String;
begin
   if Length(Str) > 0 then CleanUp := LTrim(RTrim(str, ' '), ' ') else CleanUp := Str;
end;

function strCode(S : String; N : Byte; Ins : String) : String;
var Z : Byte;
begin
   strCode := '';
   if S = '' then Exit;
   if N > 9 then N := 9;
   if N < 1 then N := 1;
   while Pos(mciHeader+'S'+St(N),S) > 0 do
   begin
      Z := Pos(mciHeader+'S'+St(N),S);
      Delete(S,Z,3);
      Insert(Ins,S,Z);
   end;
   strCode := S;
end;

function strColCode(fC,bC : Byte; bL : Boolean) : String;
var S : String;
begin
   S := '|'+St(fC);
   if Length(S) < 3 then Insert('0',S,2);
   S := S+'|'+St(bC+16);
   strColCode := S;
end;

function strColorName(C : Byte) : String;
var S : String;
begin
   S := '';
   case C of
      0   : S := 'Black';
      1   : S := 'Blue';
      2   : S := 'Green';
      3   : S := 'Cyan';
      4   : S := 'Red';
      5   : S := 'Magenta';
      6   : S := 'Brown';
      7   : S := 'Light Gray';
      8   : S := 'Dark Gray';
      9   : S := 'Light Blue';
      10  : S := 'Light Green';
      11  : S := 'Light Cyan';
      12  : S := 'Light Red';
      13  : S := 'Light Magenta';
      14  : S := 'Yellow';
      15  : S := 'White';
   end;
   strColorName := S;
end;

function strColor(C : tColorRec) : String;
var fC,bC : Byte; bL : Boolean;
begin
   fC := C.Fore;
   bC := C.Back;
   Bl := C.Blink;
   strColor := strColCode(fC,bC,bL)+strColorName(fC)+' On '+strColorName(bC)+'|16';
end;

function strCenter(S : String; Len : Integer) : String;
var Stt : String; N : Integer;
begin
   Stt := '';
   for N := 1 to (Len div 2)-(Length(S) div 2) do Stt := Stt + ' ';
   Insert(Stt,S,1);
   while Length(S) < 80 do S := S + ' ';
   strCenter := S;
end;

function strIsWild(S : String) : Boolean;
begin
   strIsWild := ((Pos('*',S) <> 0) or (Pos('?',S) <> 0));
end;

function strBkSlash(B : Boolean; S : String) : String;
begin
   if (B) then
   begin
      while (Copy(S,Length(S)-1,2) = '\\') do S := Copy(S,1,Length(S)-2);
      if (Copy(S,Length(S),1) <> '\') then S := S+'\';
   end else while (Copy(S,Length(S),1) = '\') do S := Copy(S,1,Length(S)-1);
   strBkSlash := S;
end;

function strEcho(S : String) : String;
begin
   strEcho := sRepeat(Cfg^.PwEchoChar,Length(S));
end;

function strSquish(S : String; L : Byte) : String;
begin
   while Length(NoColor(S)) > L do Dec(S[0]);
   strSquish := S;
end;

Function strHex(a : Word; b : Byte) : String;
Const digit : Array[$0..$F] Of Char = '0123456789ABCDEF';
Var i : Byte;
  xstring : String;
Begin
  xstring:='';
  For i:=1 To b Do
  Begin
    Insert(digit[a And $000F], xstring, 1);
    a:=a ShR 4
  End;
  strhex:=xstring
End; {hex}

function strReplace(S, Find, Rep : String) : String;
var Z : Byte;
begin
   strReplace := '';
   Find := UpStr(Find);
   if S = '' then Exit;
   while Pos(Find,UpStr(S)) > 0 do
   begin
      Z := Pos(Find,UpStr(S));
      Delete(S,Z,Length(Find));
      Insert(Rep,S,Z);
   end;
   strReplace := S;
end;

Function strWildCard(S1,S2:String):Boolean;
{Returns True if the wildcard description in 'S2' matches 'S1'
according to Dos wildcard principles.  The 'S2' String MUST have a period!
Example: strWildCard('test.tat','t*.t?t' returns True}

Var
   name,temp:String[12];
   c:Char;
   p,i,n,l:Byte;
   period:Boolean;

begin
    strWildCard:=True;
    {test For special Case first}
    if S1='*.*' then Exit;
    strWildCard:=False;
    p:=pos('.',S2);
    i:=pos('.',S1);
    if p > 0 then period:=True else Exit; {not a valid wildcard if no period}
    N:=1;
    Repeat
       if S2[n]='*' then n:=p-1 else
        if (upCase(S1[n]) <> upCase(S2[n])) then
         if S2[n]<>'?' then Exit;
                inc(n);
    Until n>=p;
    n:=p+1; {one position past the period of the strWildCard S2}
    l:=length(S1);
    inc(i); {one position past the period of the Filename}
    Repeat
    if n > length(S2) then Exit;
    c:=upCase(S2[n]);
         if c='*' then i:=l+1 {in order to end the loop}
          else
             if (upCase(S1[i]) = c) or (c = '?') then
                begin
                inc(n);
                inc(i);
                end
             else Exit;
    Until i > l;

    strWildCard:=True;

end;
{
function strWildCard(S1,S2 : String) : Boolean;
Var STmp1 : String[8];
    STmp2 : String[3];
    SS1, SS2 : String[12];
    I : Integer;
begin
  STmp1:=Copy(S1,1,Pos('.',S1+'.'))+'????????';
  If (Pos('.',S1)>1) then STmp2:=Copy(S1,Pos('.',S1)+1,3)+'???' else
STmp2:='???';  For I:=1 to 8 do If STmp1[I]='*' then For I:=I to 8 do
STmp1[I]:='?';  For I:=1 to 3 do If STmp2[I]='*' then For I:=I to 3 do
STmp2[I]:='?';  SS1:=STmp1+'.'+STmp2;
  STmp1:=Copy(S2,1,Pos('.',S2+'.'))+'????????';
  If (Pos('.',S2)>1) then STmp2:=Copy(S2,Pos('.',S2)+1,3)+'???' else
STmp2:='???';  For I:=1 to 8 do If STmp1[I]='*' then For I:=I to 8 do
STmp1[I]:='?';  For I:=1 to 3 do If STmp2[I]='*' then For I:=I to 3 do
STmp2[I]:='?';  SS2:=STmp1+'.'+STmp2; strWildCard:=False;
  For I:=1 to 12 do If (UpCase(SS1[I])<>UpCase(SS2[I])) and (SS2[I]<>'?') then
Exit;  strWildCard:=True;
end;
}
function strWierd(S : String) : String;
var Z : Byte;
begin
   for Z := 1 to Length(S) do if UpCase(S[Z]) in ['A','E','I','O','U'] then
             S[Z] := LowCase(S[Z]) else S[Z] := UpCase(S[Z]);
end;

function strMixed(S : String) : String;
var Z : Byte;
begin
   strMixed := '';
   if S = '' then Exit;
   S[1] := UpCase(S[1]);
   for Z := 2 to Length(S) do
      if (not (UpCase(S[Z-1]) in ['A'..'Z','0'..'9','''','"'])) then
         S[Z] := UpCase(S[Z]) else S[Z] := LowCase(S[Z]);
   strMixed := S;
end;

function strLow(s : String) : String;
var z : Byte;
begin
   for z := 1 to Ord(s[0]) do s[z] := lowCase(s[z]);
   strLow := s;
end;

function Stc(I : LongInt) : String;
VAR
   s: STRING;
   x: INTEGER;
BEGIN
   S := st(I);
   if Length(S) < 4 then
   begin
      Stc := S;
      Exit;
   end;
   x := LENGTH( s ) - 2;
   WHILE x > 1 DO BEGIN
         INSERT( ',', s, x );
         DEC( x, 3 );
   {W}END;
   Stc := s;
END;

function strFileExt(Fn : String) : String;
var S, E : String; P : Byte;
begin
   P := Pos('.',Fn);
   if P = 0 then E := '' else E := Copy(Fn,P+1,255);
   strFileExt := E;
end;

function strReal(R : Real; Ch, Dc : Byte) : String;
var S : String;
begin
   System.Str(R:Ch:Dc, S);
   strReal := S;
end;

function strEnlarge(S : String; Len : Byte) : String;
begin
   while Length(NoColor(S)) < Len do S := S+' ';
   strEnlarge := S;
end;

function strFilename(S : String) : String;
begin
   while Pos('\',S) > 0 do Delete(S,1,Pos('\',S));
   while Pos('/',S) > 0 do Delete(S,1,Pos('/',S));
   while Pos(':',S) > 0 do Delete(S,1,Pos(':',S));
   strFilename := S;
end;

function z3(n : Word) : String;
var s : string;
begin
   s := St(n);
   while Ord(s[0]) < 3 do Insert('0',s,1);
   z3 := s;
end;

function z2(n : Word) : String;
var s : string;
begin
   s := St(n);
   if Ord(s[0]) = 1 then s := '0'+s;
   z2 := s;
end;

end.